﻿/*
	This file is used to load DFFS with JSLink in SP 2013.
*/

/*
JSLint
var document, _spPageContextInfo, SPClientTemplates, window, alert, $, jQuery, setTimeout, makeAbsUrl, GetUrlKeyValue, unescape, spjs, RegisterModuleInit;
*/
Type.registerNamespace('spjs');

spjs.dffsJSLink = {
	"version":1.09,
	"lastMod":"August 16, 2015",
	"data":{"mds":false},
	"loadOverlay":function(ctx){		
		var div, b = [], script;
		try{
			div = document.createElement('div');
			div.id = "dffs_loadingOverlay";
			div.style.cssText = "padding-top:100px;text-align:center;width:100%;height:4000px;background-color:#F5F5F5;position:fixed;top:0px;z-index:9999;cursor:default;background-image:url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAYAAAAGCAYAAADgzO9IAAAALElEQVQIW2NkwALOnDnznxFdHCRoYmLCiCIBEwQphksgC8Il0AXBEtgEQRIAsDsXagWOqrQAAAAASUVORK5CYII=);";
			div.innerHTML = "<div id='dffs_loader_img'></div>";
			document.getElementsByTagName('body')[0].appendChild(div);
			script = document.createElement('script');
			b.push("setTimeout(function(){");
			b.push("var oDiv = document.getElementById(\"dffs_loadingOverlay\");");
			b.push("if(oDiv !== null){");
			b.push("oDiv.innerHTML = \"<span style='font-size:20px'>This took forever!<span style='font-size:12px'><br><br>Click to close this overlay.</span></span>\";");
			b.push("oDiv.onclick = function(){");
			b.push("this.parentNode.removeChild(this);");
			b.push("};");
			b.push("}");
			b.push("},10000);");
			script.innerHTML = b.join("");
			document.getElementsByTagName('head')[0].appendChild(script);
		}catch(ignore){
			// Ignore
		}
	},
	"listViewMsg":function(ctx){
		try{
			document.getElementById("dffs_loadingOverlay").outerHTML = "";
		}catch(ignore){
			// Nothing
		}
		return "<span style='color:red;'>Please remove this field from the list view as it breaks the  \"Minimal Download Strategy\" support.</span>";
	},
	"loadScripts":function(ctx){
		spjs.dffsJSLink.loadOverlay();
		var a = SPClientTemplates.Utility.GetFormContextForCurrentField(ctx), dffsSettings = null, path, plugins, pStatus = {}, script, link, scriptLoadCheck = {"m":500,"t":0}, jLoaded, jLoadCheck = {"m":500,"t":0}, isLoaded, head = document.getElementsByTagName('head')[0], loadPlugins, backend = GetUrlKeyValue("backend") === "1";
		try{
			dffsSettings = window.JSON.parse(unescape(a.fieldSchema.Direction));
		}catch(err){
			alert(err);
			return;
		}		
		window.dffs_loadedWithJSLink = true;
		window.spjs_dffs_backend = dffsSettings.backend;
		window.spjs_dffs_jsLink_license = dffsSettings.license;
		window.dffsRequiredFieldValidation = dffsSettings.fieldValidatonMsg;
		if(dffsSettings.configListBaseUrl !== "" && dffsSettings.configListBaseUrl !== "{currentsite}"){
			window.dffs_configListBaseUrl = dffsSettings.configListBaseUrl;
		}
		window.vLookup_configListBaseUrl = dffsSettings.vLookupConfigListBaseUrl;
		window.rm_configListBaseUrl = dffsSettings.rmConfigListBaseUrl;
		window.dffs_formTypeSwitch = dffsSettings.formTypeSwitchField;
		switch(dffsSettings.scope){
			case "site":
					path = (_spPageContextInfo.webServerRelativeUrl !== "/" ? _spPageContextInfo.webServerRelativeUrl + "/" : _spPageContextInfo.webServerRelativeUrl) + "SPJS/DFFS/";
			break;
			case "sitecollection":
					path = (_spPageContextInfo.siteServerRelativeUrl !== "/" ? _spPageContextInfo.siteServerRelativeUrl + "/" : _spPageContextInfo.siteServerRelativeUrl) + "SPJS/DFFS/";
			break;
			case "custom":
				path = dffsSettings.customFileLocation;
				path = path.replace("~sitecollection",_spPageContextInfo.siteAbsoluteUrl);
				path = path.replace("~site",_spPageContextInfo.webAbsoluteUrl);
				if(path.charAt(path.length-1) !== "/"){
					path = path+"/";
				}
			break;
		}
		// Add support for Minimal download strategy
		if(!spjs.dffsJSLink.data.mds){
			spjs.dffsJSLink.data.mds = true;
			RegisterModuleInit(path+"jslink/DFFS_JSLink.js",spjs.dffsJSLink.overrideField);
		}
		document.getElementById("dffs_loader_img").innerHTML = "<img src='"+path+"images/DFFS_loader.gif' />";
		plugins = dffsSettings.plugins;
		// Check if all plugins have loaded successfully
		isLoaded = function(){
			var pass = true, fBuffer = [];
			$.each(plugins,function(i,p){
				pStatus[p] = true;
				if(spjs[p] === undefined){
					pStatus[p] = false;
					pass = false;
					scriptLoadCheck.t += 1;
					if(scriptLoadCheck.t > scriptLoadCheck.m){
						pass = true;
					}
				}
			});			
			if(!pass){
				setTimeout(function(){
					isLoaded();
				},10);
				return false;
			}			
			$.each(pStatus,function(id,p){
				if(!p){
					if(id==="vLookup"){
						id += GetUrlKeyValue("backend") === "1" ? "_backend" : "frontend";
					}
					fBuffer.push("SPJS-"+id+".js");
				}
			});			
			// Load DFFS frontend JS and CSS
			if(backend){
				$("#s4-workspace").hide();
				$("body").prepend("<div id='dffs_backend' style='width:100%;height:100%;background-color:#f5f5f5;overflow:auto;position:absolute;top:0;left:0;z-index:9999;'></div>");
				script = document.createElement('script');
				script.src = path+"js/DFFS_backend_min.js";
				head.appendChild(script);
				link = document.createElement('link');
				link.type = "text/css";
				link.rel = "stylesheet";
				link.href = path+"css/DFFS_backend.css";
				head.appendChild(link);
				$("#dffs_loadingOverlay").remove();	
			}else{
				script = document.createElement('script');
				script.src = path+"js/DFFS_frontend_min.js";
				head.appendChild(script);
				link = document.createElement('link');
				link.type = "text/css";
				link.rel = "stylesheet";
				link.href = path+"css/DFFS_frontend.css";
				head.appendChild(link);
			}			
			// Custom plugins css
			if(dffsSettings.customPlugins !== undefined){
				$.each(dffsSettings.customPlugins.split("\n"),function(i,p){
					if(p.match(/\.css/i) !== null){
						link = document.createElement('link');
						link.type = "text/css";
						link.rel = "stylesheet";
						link.href = path+"custom/"+p;
						head.appendChild(link);
					}
				});
			}
			if(fBuffer.length > 0){
				alert("Failed to load DFFS-plugin(s):\n------------------------------------\n"+fBuffer.join("\n")+"\n\nEnsure you have these scripts in the \"DFFS\" folder in the document library \"SPJS\" here: "+makeAbsUrl(path));
			}
		};
		loadPlugins = function(){
			$.each(plugins,function(i,p){
				if(typeof spjs[p] === "undefined"){
					if(p === "vLookup"){
						if(backend){
							p = p+"_backend";
						}else{
							p = p+"_frontend";
						}
					}
					script = document.createElement('script');
					script.src = path+"plugins/SPJS-"+p+".js";
					head.appendChild(script);
				}
			});
			isLoaded();
			// Custom plugins js
			if(dffsSettings.customPlugins !== undefined){
				$.each(dffsSettings.customPlugins.split("\n"),function(i,p){
					if(p.match(/\.js/i) !== null){
						script = document.createElement('script');
						script.src = path+"custom/"+p;
						head.appendChild(script);
					}
				});
			}
		};	
		jLoaded = function(init){
			if(typeof $ !== "function"){
				if(init){
					script = document.createElement('script');
					script.src = path+"plugins/jquery.js";
					head.appendChild(script);
					jLoaded(false);
				}else{
					jLoadCheck.t += 1;
					if(jLoadCheck.t > jLoadCheck.m){
						alert("Failed to load jQuery!\n\nEnsure you have jquery.js in the \"DFFS\" folder in the document library \"SPJS\" here: "+makeAbsUrl(path));
					}else{
						setTimeout(function(){	
							jLoaded(false);
						},10);
					}
				}
			}else{
			 	loadPlugins();
			}
		};
		jLoaded(true);
		return "<span id='DFFSLoader'></span>";
	},
	"hideFields":function(){
		if(typeof jQuery !== "function"){
			setTimeout(function(){
				spjs.dffsJSLink.hideFields();
			},10);
			return;
		}
		$("#DFFSLoader").parents("tr:first").remove();
	}
};

spjs.dffsJSLink.templateOverride = {}; 
spjs.dffsJSLink.templateOverride.Templates = {}; 
//spjs.dffsJSLink.templateOverride.Templates.OnPreRender = spjs.dffsJSLink.loadOverlay;
spjs.dffsJSLink.templateOverride.Templates.OnPostRender = spjs.dffsJSLink.hideFields; 
spjs.dffsJSLink.templateOverride.Templates.Fields = { 
    "DFFS_Loader": {
    	"View":spjs.dffsJSLink.listViewMsg,
    	"NewForm":spjs.dffsJSLink.loadScripts,
    	"DisplayForm":spjs.dffsJSLink.loadScripts,
    	"EditForm":spjs.dffsJSLink.loadScripts
    }
};  
spjs.dffsJSLink.overrideField = function(){
	SPClientTemplates.TemplateManager.RegisterTemplateOverrides(spjs.dffsJSLink.templateOverride);
};
spjs.dffsJSLink.overrideField();