﻿/*
	Created by Alexander Bautz
	alexander.bautz@gmail.com
	http://sharepointjavascript.wordpress.com
	Version: 2.42
	LastMod: 24.05.2015
*/
/*
JSLint
var spjs, GetUrlKeyValue, _spPageContextInfo, alert, spjs_wrapSoapRequest, $, setTimeout, init_fields_v2, L_Menu_BaseUrl, confirm, window, getFieldValue, spjs_QueryItems, 
PreSaveAction, spjsrm_PreSaveAction, spjs_AddList, spjs_UpdateList, location, console;
*/
/* SP2013 */
if(typeof _spPageContextInfo !== "undefined"){
	if(_spPageContextInfo.webUIVersion === 15){
		var L_Menu_BaseUrl = _spPageContextInfo.webServerRelativeUrl !== "/" ? _spPageContextInfo.webServerRelativeUrl : "";
		var L_Menu_LCID = _spPageContextInfo.currentLanguage.toString();
	}
}

var spjs = spjs || {};
// The file assetpickers.js in SP365 overwrites the $ namespace.
spjs.$ = spjs.$ || $;

spjs.rm = {
	"version":"2.42",
	"data":{
		"thisId":GetUrlKeyValue('ID').split(".")[0],
		"utilityVersion":1.183,
		"isSP07":typeof _spPageContextInfo === "undefined" || _spPageContextInfo.webUIVersion === undefined,
		"isSP13":typeof _spPageContextInfo !== "undefined" && _spPageContextInfo.webUIVersion === 15 ? true : false,
		"lcidToDateFormat":{"1030":"d-m-y", "1044":"d.m.y", "5121":"d-m-y", "15361":"d/m/y", "3073":"d/m/y", "2049":"d/m/y", "11265":"d/m/y", "13313":"d/m/y", "12289":"d/m/y", "4097":"d/m/y", "6145":"d-m-y", "8193":"d/m/y", "16385":"d/m/y", "1025":"d/m/y", "10241":"d/m/y", "7169":"d-m-y", "14337":"d/m/y", "9217":"d/m/y", "1026":"d.m.y", "3076":"d/m/y", "5124":"d/m/y", "2052":"y/m/d", "4100":"d/m/y", "1028":"y/m/d", "1050":"d.m.y", "2067":"d/m/y", "1043":"d-m-y", "3081":"d/m/y", "10249":"d/m/y", "4105":"d/m/y", "16393":"d-m-y", "6153":"d/m/y", "8201":"d/m/y", "5129":"d/m/y", "13321":"m/d/y", "7177":"y/m/d", "11273":"d/m/y", "2057":"d/m/y", "1033":"m/d/y", "1080":"d-m-y", "1035":"d.m.y", "2060":"d/m/y", "3084":"y-m-d", "1036":"d/m/y", "5132":"d/m/y", "4108":"d.m.y", "3079":"d.m.y", "1031":"d.m.y", "5127":"d.m.y", "4103":"d.m.y", "2055":"d.m.y", "1038":"y.m.d", "1039":"d.m.y", "1057":"d/m/y", "1040":"d/m/y", "2064":"d.m.y", "1062":"y.m.d", "1063":"y.m.d", "1071":"d.m.y", "1086":"d/m/y", "2110":"d/m/y", "1082":"d/m/y", "1104":"y.m.d", "1045":"y-m-d", "1046":"d/m/y", "2070":"d-m-y", "1048":"d.m.y", "1049":"d.m.y", "1051":"d.m.y", "11274":"d/m/y", "16394":"d/m/y", "13322":"d-m-y", "9226":"d/m/y", "5130":"d/m/y", "7178":"d/m/y", "12298":"d/m/y", "17418":"d/m/y", "4106":"d/m/y", "18442":"d/m/y", "2058":"d/m/y", "19466":"d/m/y", "6154":"m/d/y", "15370":"d/m/y", "10250":"d/m/y", "20490":"d/m/y", "1034":"d/m/y", "14346":"d/m/y", "8202":"d/m/y", "1053":"y-m-d", "2077":"d.m.y", "1054":"d/m/y", "1055":"d.m.y"},
		"settingsListName":"SPJS-RM-BookableTimeRange",
		"settingsListDescription":"This list is used with SPJS Resource Management and stores the bookable time range for the various resources picked in the lists where this solution is activated.",
		"debug":GetUrlKeyValue("SPJSRMDebug") === "1"
	},
	"init":function(argObj){		
		// Fix for timing issue in SP 2013
		if(spjs.rm.data.isSP13){
			if(spjs.$("td.ms-formbody span[id*='"+_spPageContextInfo.pageListId.replace(/\{|\}/g,"")+"']").length>0){
				setTimeout(function(){
					spjs.rm.init(argObj);
				},10);
				return;
			}
		}
		if(spjs.rm.data.debug){
			alert("[SPJS Resource Management]\n\nDebug is activated. Ensure you have the developer console open.");
		}
		if(spjs.rm.text === undefined){
			spjs.rm.localize();
		}
		spjs.rm.data.fields = init_fields_v2();	
		// Validate
		var vArr = [{"fin":argObj.resourceField,"id":"Resource field"},{"fin":argObj.dateFrom,"id":"Start date field"},{"fin":argObj.dateTo,"id":"End date field"}];
		spjs.$.each(vArr,function(i,o){
			if(spjs.rm.data.fields[o.fin] === undefined){
				alert("[SPJS Resource Management]\n\nThe field \""+o.fin+"\" used for \""+o.id+"\" was not found. Please check the setup.");
				return;
			}
		});		
		spjs.rm.data.args = argObj;
		if(spjs.rm.data.args.listName === undefined || spjs.rm.data.args.listName === ""){
			if(!spjs.rm.data.isSP07){
				spjs.rm.data.args.listBaseUrl = _spPageContextInfo.webServerRelativeUrl !== "/" ? _spPageContextInfo.webServerRelativeUrl : "";
				spjs.rm.data.args.listName = _spPageContextInfo.pageListId;
			}else{				
				alert("SPJS Resource Management - It looks like you are using SP 2007\n\nYou must provide the listName in the argument object like this: \"listName\":\"ListGuidOrDisplayName\"");
			}
		}
		if(spjs.rm.data.isSP07){
			spjs.rm.data.args.listBaseUrl = L_Menu_BaseUrl;
		}
		spjs.rm.data.LCID = spjs.rm.getRegionalSettings(spjs.rm.data.args.listName);
		spjs.rm.data.dateFormat = spjs.rm.getDateFormat(spjs.rm.data.LCID.Locale);
		if(typeof spjs.dffs === "undefined"){
			spjs.$("#part1").after("<span style='color:gray;font-size:9px;cursor:pointer;' onclick='spjs.rm.gotoSPJS()' title='Enhanced by SPJS Resource Management v"+spjs.rm.version+"'><img src='/_layouts/images/SQUARE.GIF' /></span>");
		}
		if(spjs.rm.data.args !== undefined && spjs.rm.data.args.resourceField !== "" && spjs.rm.data.args.dateFrom !== "" && spjs.rm.data.args.dateTo !== ""){
			if(typeof PreSaveAction === "function"){
				spjsrm_PreSaveAction = PreSaveAction;	
			}			
			PreSaveAction = function(){
				spjs.$(".spjs_rm_validation").remove();
				var selectedDate, res, rVal, selectedHour_start, selectedHour_end, selectedMinute_end, bSetting, dateRange_start, dateRange_end, dateRange_start_friendlyName, dateRange_end_friendlyName, dateMinControl, dateMaxControl, dayByDayObj, timeObj, bookableDateRangesFriendly, dTemp, inDateRange, inTimeRange, vDate;				
				selectedDate = spjs.rm.validateDate();
				if(spjs.rm.data.debug){
					console.log("Current selected date and time:");										
					console.log("  "+spjs.rm.isoToCurrFormat(selectedDate.from,true)+" ("+spjs.rm.text.dayNumObj[selectedDate.from_day]+") - "+spjs.rm.isoToCurrFormat(selectedDate.to,true)+" ("+spjs.rm.text.dayNumObj[selectedDate.to_day]+")");
				}
				if(selectedDate.pass){
					res = spjs.rm.checkDateOverlap(selectedDate.from,selectedDate.to);
					rVal = getFieldValue(spjs.rm.data.args.resourceField);
					if(res.isOverlap){
						spjs.rm.appendError(spjs.rm.data.args.resourceField,spjs.rm.text.overlapMsg.replace("{0}",rVal).replace("{1}",res.bookedBy).replace("{2}",res.overlappingRangeStart).replace("{3}",res.overlappingRangeEnd));
						if(spjs.rm.data.debug){
							console.log("The selected date and time range overlaps an existilng list item.");										
						}
						return false;
					}else{
						if(spjs.rm.data.args.bookableTimeRangeActive){
							selectedHour_start = 0;
							if(spjs.$(spjs.rm.data.fields[spjs.rm.data.args.dateFrom]).find("select").length > 0){
								selectedHour_start = parseInt(spjs.$(spjs.rm.data.fields[spjs.rm.data.args.dateFrom]).find("select:first")[0].selectedIndex,10);								
							}
							selectedHour_end = 0;
							selectedMinute_end = 0;
							if(spjs.$(spjs.rm.data.fields[spjs.rm.data.args.dateTo]).find("select").length > 0){							
								selectedHour_end = parseInt(spjs.$(spjs.rm.data.fields[spjs.rm.data.args.dateTo]).find("select:first")[0].selectedIndex,10);
								selectedMinute_end = parseInt(spjs.$(spjs.rm.data.fields[spjs.rm.data.args.dateTo]).find("select:last")[0].selectedIndex,10);
							}
							bSetting = spjs_QueryItems({"listName":spjs.rm.data.settingsListName,"listBaseUrl":spjs.rm.getBaseUrl(),"query":"<Where><Eq><FieldRef Name='Title' /><Value Type='Text'>"+rVal+"</Value></Eq></Where><OrderBy><FieldRef Name='FromDate' /></OrderBy>","viewFields":["From_0","To_0","From_1","To_1","From_2","To_2","From_3","To_3","From_4","To_4","From_5","To_5","From_6","To_6","FromDate","ToDate"]});
							if(bSetting.count > 0){
								dayByDayObj = null;
								timeObj = null;
								bookableDateRangesFriendly = [];								
								spjs.$.each(bSetting.items,function(i,config){									
									dateRange_start_friendlyName = "";
									dateRange_end_friendlyName = "";
									if(config.FromDate !== null){
										dateRange_start = spjs.rm.isoToDateObj(config.FromDate);
										dateRange_start.setHours(parseInt(config["From_"+dateRange_start.getDay()],10));
										dateMinControl = spjs.rm.isoToDateObj(config.FromDate);
										dateMinControl.setHours(12);										
										config.FromDate = config.FromDate.split(" ")[0]+" "+config["From_"+dateRange_start.getDay()]+":00:00";
										dateRange_start_friendlyName = spjs.rm.isoToCurrFormat(config.FromDate,false);
									}
									if(config.ToDate !== null){
										dateRange_end = spjs.rm.isoToDateObj(config.ToDate);
										dateRange_end.setHours(parseInt(config["To_"+dateRange_end.getDay()],10));
										dateMaxControl = spjs.rm.isoToDateObj(config.ToDate);							
										dateMaxControl.setHours(12);
										config.ToDate = config.ToDate.split(" ")[0]+" "+config["To_"+dateRange_end.getDay()]+":00:00";
										dateRange_end_friendlyName = spjs.rm.isoToCurrFormat(config.ToDate,false);
									}									
									if(dateRange_start_friendlyName !== "" || dateRange_end_friendlyName !== ""){
										bookableDateRangesFriendly.push(dateRange_start_friendlyName+" - "+dateRange_end_friendlyName);
									}
									if(config.FromDate !== null && config.ToDate !== null){
										dayByDayObj = {};														
										while(dateMinControl <= dateMaxControl){																						
											dayByDayObj[dateMinControl.getFullYear()+"-"+dateMinControl.getMonth()+"-"+dateMinControl.getDate()] = {"date":dateMinControl.toDateString(),"fromHour":parseInt(config["From_"+dateMinControl.getDay()],10),"toHour":parseInt(config["To_"+dateMinControl.getDay()],10)};	
											dateMinControl.setDate(dateMinControl.getDate()+1);
										}
									}else{
										timeObj = config;
									}
								});
								// Date range
								dTemp = new Date(selectedDate.from_date.getFullYear(),selectedDate.from_date.getMonth(),selectedDate.from_date.getDate());
								inDateRange = true;
								inTimeRange = true;
								while(dTemp<selectedDate.to_date){
									if(dayByDayObj !== null){
										vDate = dayByDayObj[dTemp.getFullYear()+"-"+dTemp.getMonth()+"-"+dTemp.getDate()];
										if(vDate === undefined){ // Not in range
											if(spjs.rm.data.debug){
												console.log("Bookable range:\n"+bookableDateRangesFriendly.join("\n"));
												console.log("Not in range:");										
												console.log(new Date(dTemp.getFullYear(),(dTemp.getMonth()+1),dTemp.getDate()));
											}
											inDateRange = false;
											break;
										}else{
											if(selectedDate.from_date.toDateString() === vDate.date){
												if(vDate.fromHour > selectedHour_start){
													if(spjs.rm.data.args.timeFormat === "12"){
														vDate.fromHour = spjs.rm.milToAmPm(vDate.fromHour);
													}else{
														vDate.fromHour = vDate.fromHour+":00";
													}
													if(spjs.rm.data.debug){
														console.log("Time must be >= "+vDate.fromHour);
													}												
													spjs.rm.appendError(spjs.rm.data.args.dateFrom,spjs.rm.text.notInTimeRange[0].replace("{0}",rVal).replace("{1}",vDate.fromHour).replace("{2}",spjs.rm.text.dayNumObj[selectedDate.from_day]));
													inTimeRange = false;
													break;
												}
											}
											if(selectedDate.to_date.toDateString() === vDate.date){
												if(vDate.toHour < selectedHour_end || (vDate.toHour === selectedHour_end && selectedMinute_end > 0)){
													if(spjs.rm.data.args.timeFormat === "12"){
														vDate.toHour = spjs.rm.milToAmPm(vDate.toHour);
													}else{
														vDate.toHour = vDate.toHour+":00";
													}
													if(spjs.rm.data.debug){
														console.log("Time must be <= "+vDate.toHour);
													}	
													spjs.rm.appendError(spjs.rm.data.args.dateTo,spjs.rm.text.notInTimeRange[1].replace("{0}",rVal).replace("{1}",vDate.toHour).replace("{2}",spjs.rm.text.dayNumObj[selectedDate.to_day]));
													inTimeRange = false;
													break;
												}
											}
										}
									}else{
										if(parseInt(timeObj["From_"+selectedDate.from_day],10) > selectedHour_start){
											if(spjs.rm.data.args.timeFormat === "12"){
												timeObj.fromHour = spjs.rm.milToAmPm(timeObj["From_"+selectedDate.from_day]);
											}else{
												timeObj.fromHour = timeObj["From_"+selectedDate.from_day]+":00";
											}
											if(spjs.rm.data.debug){
												console.log("Time must be >= "+timeObj["From_"+selectedDate.from_day]);
											}												
											spjs.rm.appendError(spjs.rm.data.args.dateFrom,spjs.rm.text.notInTimeRange[0].replace("{0}",rVal).replace("{1}",timeObj.fromHour).replace("{2}",spjs.rm.text.dayNumObj[selectedDate.from_day]));
											inTimeRange = false;
											break;
										}
										if(parseInt(timeObj["To_"+selectedDate.from_day],10) < selectedHour_end || (parseInt(timeObj["To_"+selectedDate.from_day],10) === selectedHour_end && selectedMinute_end > 0)){
											if(spjs.rm.data.args.timeFormat === "12"){
												timeObj.toHour = spjs.rm.milToAmPm(timeObj["To_"+selectedDate.to_day]);
											}else{
												timeObj.toHour = timeObj["To_"+selectedDate.to_day]+":00";
											}
											if(spjs.rm.data.debug){
												console.log("Time must be <= "+timeObj["To_"+selectedDate.to_day]);
											}	
											spjs.rm.appendError(spjs.rm.data.args.dateTo,spjs.rm.text.notInTimeRange[1].replace("{0}",rVal).replace("{1}",timeObj.toHour).replace("{2}",spjs.rm.text.dayNumObj[selectedDate.to_day]));
											inTimeRange = false;
											break;
										}
									}									
									dTemp.setDate(dTemp.getDate()+1);
								}
								if(!inDateRange){
									spjs.rm.appendError(spjs.rm.data.args.resourceField,spjs.rm.text.bookableDateRange.replace("{0}",rVal).replace("{1}",bookableDateRangesFriendly.join("<br>")));
									return false;
								}
								if(!inTimeRange){
									return false;
								}
							}
						}
					}
				}else{		
					return false;
				}
				if(typeof spjsrm_PreSaveAction === "function"){
					return spjsrm_PreSaveAction();
				}else{
					return true;
				}
			};
		}
	},
	"getBaseUrl":function(){
		var baseUrl;
		if(typeof rm_configListBaseUrl !== "undefined"){
			baseUrl = (rm_configListBaseUrl === "{currentsite}" ? L_Menu_BaseUrl : rm_configListBaseUrl);
		}else{
			if(spjs.rm.data.isSP07){
				baseUrl = L_Menu_BaseUrl;
			}else{
				baseUrl = _spPageContextInfo.webServerRelativeUrl !== "/" ? _spPageContextInfo.webServerRelativeUrl : "";
			}
		}
		return baseUrl;
	},
	"addOrUpdateList":function(hasList){		
		if(spjs.utility === undefined || spjs.utility.version < spjs.rm.data.utilityVersion){
			alert("[SPJS Resource Management plugin]\n\nYour current version of SPJS-Utility.js is: "+String(spjs.utility.version)+". You must upgrade to v"+String(spjs.rm.data.utilityVersion)+" or above.");
			return;
		}
		if(!hasList && !confirm("Add or update the list: "+spjs.rm.data.settingsListName+"?")){
			return;
		}
		var tc = ["<CHOICES>"], c = 0, fBase, fMissing, fDetails, lFields, newList, updList, baseUrl = spjs.rm.getBaseUrl(), dFieldsRaw, dFields;
		while(c < 24){
			tc.push("<CHOICE>"+(c < 10 ? "0"+c.toString() : c.toString())+"</CHOICE>");
			c += 1;
		}
		tc.push("</CHOICES>");
		fBase = [{'Type':'Choice','DisplayName':'From_1','AddToView':'1'},
			{'Type':'Choice','DisplayName':'To_1','AddToView':'1'},	
			{'Type':'Choice','DisplayName':'From_2','AddToView':'1'},
			{'Type':'Choice','DisplayName':'To_2','AddToView':'1'},
			{'Type':'Choice','DisplayName':'From_3','AddToView':'1'},
			{'Type':'Choice','DisplayName':'To_3','AddToView':'1'},
			{'Type':'Choice','DisplayName':'From_4','AddToView':'1'},
			{'Type':'Choice','DisplayName':'To_4','AddToView':'1'},
			{'Type':'Choice','DisplayName':'From_5','AddToView':'1'},
			{'Type':'Choice','DisplayName':'To_5','AddToView':'1'},
			{'Type':'Choice','DisplayName':'From_6','AddToView':'1'},
			{'Type':'Choice','DisplayName':'To_6','AddToView':'1'},
			{'Type':'Choice','DisplayName':'From_0','AddToView':'1'},
			{'Type':'Choice','DisplayName':'To_0','AddToView':'1'},
			{'Type':'DateTime','DisplayName':'FromDate','AddToView':'1'},
			{'Type':'DateTime','DisplayName':'ToDate','AddToView':'1'}];
		fDetails = [{'Type':'Text','Name':'Title','DisplayName':'Resource name','Description':'','spjsRMVersion':spjs.rm.version},
			{'Type':'Choice','Format':'Dropdown','Name':'From_1','DisplayName':'Monday from','content':tc.join("")+"<Default>06</Default>",'Description':''},
			{'Type':'Choice','Format':'Dropdown','Name':'To_1','DisplayName':'to','content':tc.join("")+"<Default>20</Default>",'Description':''},
			{'Type':'Choice','Format':'Dropdown','Name':'From_2','DisplayName':'Tuesday from','content':tc.join("")+"<Default>06</Default>",'Description':''},
			{'Type':'Choice','Format':'Dropdown','Name':'To_2','DisplayName':'to','content':tc.join("")+"<Default>20</Default>",'Description':''},
			{'Type':'Choice','Format':'Dropdown','Name':'From_3','DisplayName':'Wednesday from','content':tc.join("")+"<Default>06</Default>",'Description':''},
			{'Type':'Choice','Format':'Dropdown','Name':'To_3','DisplayName':'to','content':tc.join("")+"<Default>20</Default>",'Description':''},
			{'Type':'Choice','Format':'Dropdown','Name':'From_4','DisplayName':'Thursday from','content':tc.join("")+"<Default>06</Default>",'Description':''},
			{'Type':'Choice','Format':'Dropdown','Name':'To_4','DisplayName':'to','content':tc.join("")+"<Default>20</Default>",'Description':''},
			{'Type':'Choice','Format':'Dropdown','Name':'From_5','DisplayName':'Friday from','content':tc.join("")+"<Default>06</Default>",'Description':''},
			{'Type':'Choice','Format':'Dropdown','Name':'To_5','DisplayName':'to','content':tc.join("")+"<Default>20</Default>",'Description':''},
			{'Type':'Choice','Format':'Dropdown','Name':'From_6','DisplayName':'Saturday from','content':tc.join("")+"<Default>06</Default>",'Description':''},
			{'Type':'Choice','Format':'Dropdown','Name':'To_6','DisplayName':'to','content':tc.join("")+"<Default>20</Default>",'Description':''},
			{'Type':'Choice','Format':'Dropdown','Name':'From_0','DisplayName':'Sunday from','content':tc.join("")+"<Default>06</Default>",'Description':''},
			{'Type':'Choice','Format':'Dropdown','Name':'To_0','DisplayName':'to','content':tc.join("")+"<Default>20</Default>",'Description':''},
			{'Type':'DateTime','Name':'FromDate','DisplayName':'From date [Optional] ','Format':'DateOnly','Description':'Bookable FROM this date.'},
			{'Type':'DateTime','Name':'ToDate','DisplayName':'To date [Optional]','Format':'DateOnly','Description':'Bookable TO this date.'}];
		if(hasList){
			fMissing = [];
			lFields = spjs.rm.getListFields(spjs.rm.data.settingsListName,baseUrl);
			if(lFields.spjsRMVersion === spjs.rm.version){
				alert("Your configuration list is already updated to the latest version.");
				return;
			}else if(lFields.spjsRMVersion === ""){
				dFieldsRaw = ["From","To"];
				dFields = [];
				spjs.$.each(dFieldsRaw,function(i,fin){
					if(lFields[fin] !== undefined){
						dFields.push(fin);
					}
				});
				if(dFields.length > 0 && confirm("It looks like you are upgrading from a version prior to v2.2.\n\nYou must remove these fields from the configuration list:\n\n"+dFields.join(", ")+"\n\nClick OK to do this automatically, or open the list and do it manually.")){
					updList = spjs_UpdateList(spjs.rm.data.settingsListName,baseUrl,[],[],dFields);
					if(updList.success){
						alert("The fields were deleted successfully.");
					}else{
						alert(updList.errorText);
					}
				}
			}
			spjs.$.each(fBase,function(i,o){
				if(lFields[o.DisplayName] === undefined){
					fMissing.push(o);
				}
			});
			fBase = fMissing;
		}else{
			newList = spjs_AddList(spjs.rm.data.settingsListName,baseUrl,spjs.rm.data.settingsListDescription);
		}
		if(hasList || newList.success){
			updList = spjs_UpdateList(spjs.rm.data.settingsListName,baseUrl,fBase,fDetails);
			if(!updList.success){
				alert("[SPJS RM UpdateList]\n\n"+updList.errorText);
			}else{
				alert("The list was added / updated successfully. The page will reload.");
				location.href = location.href;
			}
		}else{
			alert("[spjs_AddList]\n\nAn error occurred.");
		}
	},
	"getListFields":function(listName,listBaseUrl){
		var b = [], f = {};
		b.push('<GetList xmlns="http://schemas.microsoft.com/sharepoint/soap/">');
		b.push('<listName>' + listName + '</listName>');
		b.push('</GetList>');
		spjs_wrapSoapRequest(listBaseUrl + '/_vti_bin/lists.asmx', 'http://schemas.microsoft.com/sharepoint/soap/GetList', b.join(''), function(data){
			spjs.$(data).find('Field').each(function(){
				if(spjs.$(this).attr('Name') === "Title"){
					f.spjsRMVersion = spjs.$(this).attr('spjsRMVersion');
					if(f.spjsRMVersion === undefined){
						f.spjsRMVersion = "";
					}
				}
				if(spjs.$(this).attr('DisplayName')!==undefined){
					f[spjs.$(this).attr('Name')] = {"disp":spjs.$(this).attr('DisplayName'),"descr":spjs.$(this).attr('Description')};
				}
			});
		});
		return f;
	},
	"verifyTimeRangeList":function(){
		if(!spjs.rm.hasList()){
			spjs.rm.addOrUpdateList(false);
		}else{
			if(confirm("The list \""+spjs.rm.data.settingsListName+"\" exists, check for updates?")){
				spjs.rm.addOrUpdateList(true);
			}
		}
	},
	"hasList":function(){
		var res = spjs_QueryItems({"listName":spjs.rm.data.settingsListName,"listBaseUrl":spjs.rm.getBaseUrl(),"query":"<Where><IsNotNull><FieldRef Name='ID' /></IsNotNull></Where>","viewFields":["ID"],"rowLimit":1});
		if(res.count < 0){
			return false;
		}else{
			return true;
		}
	},
	"getDateFormat":function(lcid){
		var sep, format;
		if(spjs.rm.data.lcidToDateFormat[lcid] !== undefined){
			sep = spjs.rm.data.lcidToDateFormat[lcid].match(/[^dmy]/)[0];
			format = spjs.rm.data.lcidToDateFormat[lcid].split(sep).join("");
			return {'full':spjs.rm.data.lcidToDateFormat[lcid],'format':format,'separator':sep};
		}else{	
			alert("The date format for LCID "+lcid+" is not configured.\n\nEither make a request for an update here:\nhttp://spjsblog.com\n\nOr add the correct format in the variable \"spjs.rm.data.lcidToDateFormat\".");
		}
	},
	"getRegionalSettings":function(listName){
		var b, r;
		b = [];
		b.push('<GetList xmlns="http://schemas.microsoft.com/sharepoint/soap/">');
		b.push('<listName>' + listName + '</listName>');
		b.push('</GetList>');
		r = {success:false};
		spjs_wrapSoapRequest(spjs.rm.data.args.listBaseUrl + '/_vti_bin/lists.asmx', 'http://schemas.microsoft.com/sharepoint/soap/GetList', b.join(''), function(data){
			r.Language = spjs.$(data).find('RegionalSettings').find('Language').text();
			r.Locale = spjs.$(data).find('RegionalSettings').find('Locale').text();
		});
		return r;
	},
	"localize":function(){
		spjs.rm.text = {
			"overlapMsg":"{0} has already been booked by {1} between {2} and {3}.",
			"endBeforeStartMsg":"End time cannot be less than or equal to start time.",
			"empty":"{0} cannot be left empty!",
			"wrongDateFormat":"Please use this date format: {0}",
			"notInTimeRange":["{0} can be booked from {1} on a {2}.","{0} can be booked to {1} on a {2}."],
			"notInDateRange":["{0} cannot be booked before {1}.","{0} cannot be booked after {1}."],
			"bookableDateRange":"The bookable date ranges for {0} are:<br>{1}",
			"dayNumObj":{0:"Sunday",1:"Monday",2:"Tuesday",3:"Wednesday",4:"Thursday",5:"Friday",6:"Saturday"}
		};
	},	
	"gotoSPJS":function(){
		if(confirm("This will open http://spjsblog.com in a new window.\n\nProceed?")){
			window.open('http://spjsblog.com/2014/04/20/resource-management-now-compatible-with-dffs/');
		}
	},
	"appendError":function(fin,msg){
		var tabId, ct;
		spjs.$(spjs.rm.data.fields[fin]).find('td.ms-formbody:last').append("<div id='spjs_rm_validation_"+fin+"' class='spjs_rm_validation' style='display:none;color:red;'>"+msg+"</div>").focus();
		spjs.$("#spjs_rm_validation_"+fin).fadeIn(200);
		if(typeof spjs.dffs !== "undefined"){
			// Highligth tab
			spjs.$("#tabWrapper").find('li.tabBase').each(function(i,li){
				tabId = li.id;
				if(spjs.$.inArray(fin,spjs.dffs.data.tabConfigObj[tabId.split("_")[2]].fields)>-1){						
					ct = spjs.$("#"+tabId);
					if(!ct.hasClass('tabFormValidation')){
						ct.addClass('tabFormValidation');
					}											
					return false;
				}
			});
		}
	},
	"checkDateOverlap":function(start,end){
		var qb, res, result;
		result = {isOverlap:false};
		qb = [];
		qb.push("<And>");
		qb.push("<And>");
		qb.push("<Leq>");
		qb.push("<FieldRef Name='"+spjs.rm.data.args.dateFrom+"' /><Value Type='DateTime' IncludeTimeValue='TRUE'>"+end+"</Value>");
		qb.push("</Leq>");
		qb.push("<Geq>");
		qb.push("<FieldRef Name='"+spjs.rm.data.args.dateTo+"' /><Value Type='DateTime' IncludeTimeValue='TRUE'>"+start+"</Value>");
		qb.push("</Geq>");	
		qb.push("</And>");
		qb.push("<Eq>");
		qb.push("<FieldRef Name='"+spjs.rm.data.args.resourceField+"' /><Value Type='Text'>"+getFieldValue(spjs.rm.data.args.resourceField)+"</Value>");
		qb.push("</Eq>");	
		qb.push("</And>");
		if(spjs.rm.data.thisId!==''){
			qb.unshift("<And>");
			qb.push("<Neq>");
			qb.push("<FieldRef Name='ID' /><Value Type='Integer'>"+spjs.rm.data.thisId+"</Value>");
			qb.push("</Neq>");	
			qb.push("</And>");
		}
		qb.unshift("<Where>");
		qb.push("</Where>");
		res = spjs_QueryItems({"listName":spjs.rm.data.args.listName,"listBaseUrl":spjs.rm.data.args.listBaseUrl,"query":qb.join(''),"viewFields":["ID","Title","Editor",spjs.rm.data.args.dateFrom,spjs.rm.data.args.dateTo]});
		if(res.count>0){
			result.isOverlap = true;		
			result.overlappingRangeStart = spjs.rm.isoToCurrFormat(res.items[0][spjs.rm.data.args.dateFrom],true);
			result.overlappingRangeEnd = spjs.rm.isoToCurrFormat(res.items[0][spjs.rm.data.args.dateTo],true);
			result.bookedBy = res.items[0].Editor.split(';#')[1];
		}else{
			return false;
		}
		return result;
	},
	"milToAmPm":function(hour,min){
		var h, ampm;
		ampm = " AM";
		h = parseInt(hour,10);
		if(h>12){
			h = h-12;
			ampm = " PM";
		}
		return h+":"+(min !== undefined ? min : "00")+ampm;
	},
	"isoToCurrFormat":function(str,includeTime){
		var sep, formatArr, strSplit, time, obj;
		if(str===null){
			return "";
		}
		sep = spjs.rm.data.dateFormat.separator;
		formatArr = spjs.rm.data.dateFormat.full.split(sep);
		strSplit = str.split(/T| |:|-|z/i);	
		obj = {'y':strSplit[0],'m':strSplit[1],'d':strSplit[2]};
		if(includeTime){
			time = strSplit[3]+":"+strSplit[4];
			if(spjs.rm.data.args.timeFormat==="12"){
				time = spjs.rm.milToAmPm(strSplit[3],strSplit[4]);
			}
			return obj[formatArr[0]]+sep+obj[formatArr[1]]+sep+obj[formatArr[2]]+" "+time;
		}else{
			return obj[formatArr[0]]+sep+obj[formatArr[1]]+sep+obj[formatArr[2]];
		}	
	},
	"isoToDateObj":function(str){
		var strSplit, time, obj;
		if(str===null){
			return '';
		}
		strSplit = str.split(/T| /)[0].split('-');	
		obj = {'y':strSplit[0],'m':strSplit[1],'d':strSplit[2]};
		time = str.substring(11,16).split(":");
		return new Date(parseInt(obj.y,10),parseInt(obj.m,10)-1,parseInt(obj.d,10),time[0],time[1]);
	},
	"strToDateObj":function(fin){
		var fullDate, year, month, day, hour, min, dArr;
		fullDate = spjs.$(spjs.rm.data.fields[fin]).find('input:first').val();
		hour = "12";
		min = "00";
		if(spjs.$(spjs.rm.data.fields[fin]).find("select").length > 0){
			hour = spjs.$(spjs.rm.data.fields[fin]).find('select:first')[0].selectedIndex;
			min = spjs.$(spjs.rm.data.fields[fin]).find('select:last').val();
		}
		if(fullDate===''){
			return false;
		}
		dArr = fullDate.split(spjs.rm.data.dateFormat.separator);
		if(dArr.length<3){
			return false;
		}
		year = dArr[spjs.rm.data.dateFormat.format.indexOf('y')].toString();
		month = dArr[spjs.rm.data.dateFormat.format.indexOf('m')].toString();
		day = dArr[spjs.rm.data.dateFormat.format.indexOf('d')].toString();
		if(year==='' || month==='' || day===''){
			return false;
		}
		if(year.length===2){
			year = "20"+year;
		}
		return new Date(parseInt(year,10),parseInt(month,10)-1,parseInt(day,10),hour,min);
	},
	"validateDate":function(){
		var dateRangeArr, fullDate, cDate, cDatedArr, result, key;
		cDatedArr = [];
		result = {pass:true};
		dateRangeArr = [spjs.rm.data.args.dateFrom,spjs.rm.data.args.dateTo];
		spjs.$.each(dateRangeArr,function(i,fin){
			spjs.$("#spjs_rm_validation_"+fin).remove();
			fullDate = spjs.$(spjs.rm.data.fields[fin]).find('input:first').val();
			if(fullDate===''){
				spjs.rm.appendError(fin,spjs.rm.text.empty.replace("{0}",spjs.$(spjs.rm.data.fields[fin]).attr('FieldDispName')));			
				result.pass = false;		
				return false;
			}else{
				spjs.$.each(fullDate.split(/[^\d]/),function(j,v){
					if(parseInt(v,10) < 1){
						result.pass = false;
						spjs.rm.appendError(fin,spjs.rm.text.wrongDateFormat.replace("{0}",spjs.rm.data.lcidToDateFormat[spjs.rm.data.LCID.Locale]));
						return false;						
					}
				});
			}
			cDate = spjs.rm.strToDateObj(fin);
			if(!cDate){
				spjs.rm.appendError(fin,spjs.rm.text.wrongDateFormat.replace("{0}",spjs.rm.data.lcidToDateFormat[spjs.rm.data.LCID.Locale]));
				result.pass = false;
				return false;
			}			
			// Handle consecutive booking by adding or subtracting one minute when searching for overlapping date ranges
			if(cDatedArr.length===0){
				cDate.setMinutes(cDate.getMinutes()+1);
			}else{
				cDate.setMinutes(cDate.getMinutes()-1);
			}
			cDatedArr.push(cDate);
			key = "from";
			if(i > 0){
				key = "to";
			}
			result[key] = cDate.getFullYear().toString()+"-"+(cDate.getMonth()+1).toString()+"-"+cDate.getDate().toString()+"T"+cDate.getHours().toString()+":"+cDate.getMinutes().toString()+":00Z";
			result[key+"_day"] = cDate.getDay();
			result[key+"_date"] = cDate;
			if(cDatedArr.length>1){			
				if(cDatedArr[0]>=cDatedArr[1]){
					spjs.rm.appendError(fin,spjs.rm.text.endBeforeStartMsg);
					result.pass = false;
					return false;
				}
			}		
		});
		return result;
	},
	"toISO8601":function(date){
		if(date === null){
			return null;
		}
		var y, m, d, min, hour;
		y = date.getFullYear().toString();
		m = (date.getMonth()+1).toString();
		d = date.getDate().toString();
		min = date.getMinutes().toString();
		if(min.length<2){
			min = "0"+min;
		}
		hour = date.getHours().toString();
		if(hour.length<2){
			hour = "0"+hour;
		}
		return y+"-"+m+"-"+d+"T"+hour+":"+min+":00";
	}
};